;
; Programm zum Sortieren des Datenfeldes von feldA bis einschlielich feldE
; in aufsteigender Folge der Werte.
;
		.text

; R1 - Addresse vom Anfang der Liste
;
; R3 - Flag, das zeigt ob geswaped wurde oder nicht
; R4 - Addresse, die hochgezhlt wird in jedem Durchlauf
; R5 - Zahl                 \_ sind zu sortieren
; R6 - Nachfolger von Zahl  /
; R7 - Vergleichsspeicher   (Reihenfolge richtig, wenn 0)
; R8 - Zhler, der mit der Lnge vom feld - 1 geladen wird
; R9 - Lnge = feldE - feldA

start:		LHI	R1,feldA>>16		; lade R1 und R2 wie bekannt
		ORI	R1,R1,feldA&0xffff
		LHI	R9,(feldE-feldA)>>16
		ORI	R9,R9,(feldE-feldA)&0xffff

;	bei jedem neuen Durchlauf setzen

new:		add	r4,r1,r0		; R4 = Addresse vom Anfang
		add	r8,r9,r0		; R8 = Lnge
		add	r3,r0,r0		; Flag auf Null
		subi	r9,r9,4			; nach jedem Durchlauf immer ein Element weniger!
		beqz	r8, final		; wenn = 0, sind alle Elemente in aufsteigender Folge

;	Durchlauf der Liste, bei jedem Duchlauf wird das grte gefundene Element
;	an das Ende der Liste Verschoben.

loop:		lw	r5, 0(r4)		; lade die Werte
		lw	r6, 4(r4)
		subi	r8,r8,0x4		; verkleiner den Zhler
		sgt	r7, r5, r6		; bestimme ob R5 > R6
		addi	r4,r4,0x4		; erhhe Adresse fr nchsten durchlauf
		beqz	r7, noswap		; wenn R5 > R6 vertausche, sonst berspringe
		addi	r3,r3,0x1		; setze swap Flagauf 1
		sw	-4(r4),r6		; da r4 bereits erhht wurde, ndern sich die offsets
		sw	0(r4),r5
noswap:		bnez	r8, loop		; wenn zhler nicht 0 ist (also liste fertig) mache weiter
		bnez	r3, new			; sonst, wenn mind. 1x geswaped wurde, laufe die Liste nochmal durch,

final:		trap	0			; sonst fertig

       
		.data

		.word	0xee
		.word	0xee

;	zu sortierendes Datenfeld

feldA:		.word	0xf
		.word	0xe
		.word	0xd
		.word	0xc
		.word	0xb
		.word	0xa
		.word	0x9
		.word	0x8
		.word	0x7
		.word	0x6
		.word	0x5
		.word	0x4
		.word	0x3
		.word	0x2
feldE:		.word	0x1

		.word	0xee
		.word	0xee

