;*********** WINDLX Bsp.2: Primzahlentabelle erzeugen *************
;*********** (c) 1991 Gnther Raidl                   *************
;*********** 32 Bit Adressen 2004 Siegmar Schne      *************

;-------------------------------------------------------------------
; Programmanfang bei Symbol main
; Erzeugt eine Tabelle der ersten Count Primzahlen ab Table
;-------------------------------------------------------------------


		.data

		;*** Gre der zu erzeugenden Primzahlentabelle
		.global		Count
Count:		.word		10
		.global		Table
Table:		.space		10*4
EndTbl:


		.text
		.global	main
main:
		;*** Initialisierungen
		lhi		r12,Count >> 16
		ori		r12,r12,Count & 0xffff

		addi		r1,r0,0		;Index in Table
		addi		r2,r0,2		;Aktueller, betrachteter Wert

		;*** Feststellen, ob Wert in R2 durch einen Wert in der Tabelle teilbar ist
NextValue:	addi		r3,r0,0		;Hilfeindex in Table
Loop:		seq		r4,r1,r3	;Tabellenende erreicht?
		bnez		r4,IsPrim	;Wert in R2 ist eine Primzahl
		add		r13,r12,r3	; r3 + Basisadresse
		lw		r5,Table-Count(R13)	;Tabellenwert auf Platz R3 holen
		divu		r6,r2,r5	;Modulo-Wert berechnen (->R8)
		multu		r7,r6,r5
		subu		r8,r2,r7
		beqz		r8,IsNoPrim	;Ganzzahlig teilbar, keine Primzahl
		addi		r3,r3,4		;Zum nchsten Tabelleneintrag
		j		Loop

IsPrim:		;*** Wert in Table eintragen und Index erhhen
		add		r13,r12,r1	; r1 + Basisadresse
		sw		Table-Count(r13),r2
		addi		r1,r1,4

		;*** Notwendige Anzahl erreicht?
		lw		r9,Count-Count(r12)	;Gewnschte Anzahl
		srli		r10,r1,2	;Aktuelle Anzahl errechnen (/4)
		sge		r11,r10,r9
		bnez		r11,Finish

IsNoPrim:	;*** Nchsten Wert berprfen
		addi		r2,r2,1		;R2 um eins erhhen
		j		NextValue
		
Finish:		;*** Programmende
		trap		0
		
		
