;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                          ;
; Beisp.4 Addition zweier Werte, Nutzung der E/A syscalls  ;
;                                                          ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; Addition von 2 einzugebenden Werten und Anzeige der Summe

; Die Operanden werden dezimal eingegeben und das Ergebnis
; soll auch dezimal angezeigt werden.

; Nutzung von Unterprogrammen,
; syscall 3 und syscall 5 fr E/A, syscall 0 beendet Abarbeitung 

		.data

text1:		.asciiz	"\n\nAddition zweier Summanden\n\n1.Summand = "

text2:		.asciiz	"\n2.Summand = "

text3:		.asciiz	"\n_ Summe __= %d"

input_puffer:	.space	30

		.text
start:	
		ori	r4,	r0,	text1		; Ausgabe 1.Text
		jal	print_string

		jal	inwert				; Rckgabeparameter in r26
		beqz	r25,	wertio
		addi	r29,	r0,	-1
		beq	r25,	r29,	start
		j	ende

wertio:		addu	r24,	r0,	r26		; 1.Summanden nach R4

ws2:		ori	r4,	r0,	text2		; Ausgabe 2.Text
		jal	print_string


		jal	inwert				; Rckgabeparameter in r26
		beqz	r25,	w2io
		addi	r29,	r0,	-1
		bne	r25,	r29,	ws2
		j	ende

w2io:		add	r5,	r24,	r26		; R4 = Summe
		ori	r4,	r0,	text3
		jal	print_string
		j	start


ende:		syscall	0

; Unterprogramme
; ==============


; 1. Eingabe eines 32 Bit Wertes zeichenweise(ASCII)
;    mit Konvertierung dez -> hex

;   OUT:  R25 = ^A Status
;         R26 = WERT
;   KILL: R1, R4, R14, R27, R28, R30, R31

inwert:		add	r30,	r0,	r31		; Rcksprung retten
		add	r25,	r0,	r0		; clr	r25, Kein PG Ende
		add	r26,	r0,	r0		; clr	r26, Eingabewert lschen
		ori	r4,	r0,	input_puffer
		jal	input_string

		ori	r14,	r0,	input_puffer
		slti	r15,	r1,	11		; Maximal 10 Stellen
		beqz	r15,	inwerr			; mehr als 10 Stellen eingegeben!
		beqz	r1,	inwpge			; keine Eingabe -> PG-ENDE
		
inwzyk:		lbu	r27,	0(r14)
		addiu	r14,	r14,	1
		addiu	r1,	r1,	-1
		slti	r28,	r27,	0x30		; "0"	;Kleiner "0" ?
		bnez	r28,	inwerr			; unzulssige Eingabe
		ori	r28,	r0,	0x39
		slt	r28,	r28,	r27		; "9"	;Grer  "9" ?
		bnez	r28,	inwerr			; unzulssige Eingabe
		andi	r27,	r27,	0xf		; ASCII -> HEX
		sll	r28,	r26,	3		; N*8
		sll	r26,	r26,	1		; N*2
		addu	r26,	r28,	r26		; N*8+N*2=N*10
		addu	r26,	r26,	r27		; +Eingabewert
		bnez	r1,	inwzyk

		ori	r4,	r0,	input_puffer	; Eingabe noch auf der Konsole anzeigen
		jal	print_string
		jr	r30

inwerr:		addi	r25,	r0,	-1		; Eingabe Wiederholen
		jr	r30
inwpge:		addiu	r25,	r0,	1		; PG-ENDE
inwen:		jr	r30

; 2. Ausgabe eines internen Wertes als 
		#include	print1.s

; 3. Eingabe einer Zeichenkette
		#include	input.s

