;
; Beispiel 7
; ==========
;
; Kommandoverzweigung mit 2 Tabellen
; ==================================
; (mit Benutzung des Stack im UP)
;

		.data


; Adressen der Kommandos (eduMIPS kann keine Programm Adressen in .data verwenden !)

ADRTAB: 	.word   0x70	;KOM01
		.word   0x7C	;KOM02
		.word   0x88	;KOM03
		.word   0x94	;KOM04
		.word   0xA0	;KOM05
		.word   0xAC	;KOM06
		.word   0xB8	;ENDE
EADRT:

; Liste der Kommandos

KOMTAB: 	.ascii  "1234567"
EKOM:

TX1:		.asciiz "\n\nKommandoverzweigung mit Tabellen\nKommando = "

TX2:		.asciiz "\nUnzulaessiges Kommando !!! "

TXK1:		.asciiz "\nKommando 01 wurde gestartet !!"

TXK2:		.asciiz "\nKommando 02 wurde gestartet !!"

TXK3:		.asciiz "\nKommando 03 wurde gestartet !!"

TXK4:		.asciiz "\nKommando 04 wurde gestartet !!"

TXK5:		.asciiz "\nKommando 05 wurde gestartet !!"

TXK6:		.asciiz "\nKommando 06 wurde gestartet !!"

TXK7:		.asciiz "\nauf Wiedersehen !!!"

TXinierr:	.asciiz	"\nDie Anzahl der Elemente in ADRTAB ist\n nicht gleich der Anzahl der Kommandos!"

input_puffer:	.space	30

; Programmstack fuer 40 Worte reservieren

;		.align  2
		.space	200	;40*4 =160
STACK:


		.text

START:		ori	r29,r0,STACK		; Stackobergrenze in R29 laden
						; R29 = STACKPOINTER
;      Initialisierung der Kommandoadresstabelle

		ori	r5,r0,ADRTAB		; Start Adresse der Tabelle
		ori	r6,r0,EADRT		; 1. Adresse hinter der Tabelle
		ori	r7,r0,EKOM - KOMTAB	; Anzahl der Kommandos
		addi	r7,r7,-1		; Anzahl der Kommandos -1
; eduMIPS kann auch keine Programmadressen in Register laden
		ori	r8,r0,0x70	;KOM01	; Adresse des 1. Kommandos
		ori	r9,r0,0xc	;EKOM01 - KOM01	; Laenge des Kommandos
init:		sd	r8, 0(r5)		; Kommandoadresse initialisieren
		addi	r5,r5,8			; 64 Bit Tabelle
		addi	r7,r7,-1		; Anzahl der Kommandos -1
		addu	r8,r8,r9		; Adresse des naechsten Kommandos
		bne	r7,r0,init
		beq	r5,r6,KOMIN
		ori	r4,r0,TXinierr
		jal     print_string
		syscall	0

KOMIN:		ori	r4,r0,TX1
		jal     print_string

; Eingabe des Kommando (muss mit ENTER abgeschlossen werden)

		jal     INCHAR
		beq	r25,r0,	wertio
		addi	r26,	r0,	-1
		beq	r25,	r26,	START
		j	ENDE

wertio:	
		jal     UP_KOMV			; Kommando auswerten

		jr      r20			; Kommando starten

; Falsches Kommando

		ori	r4,r0,TX2
		jal     print_string

		j       KOMIN

; Alle Kommandos muessen den gleichen Aufbau und damit auch die gleiche
; Laenge haben, sonst funtioniert die Initialisierung von ADRTAB nicht!

; Kommando 01

KOM01:
		ori	r4,r0,TXK1
		jal     print_string

		j       KOMIN
EKOM01:

; Kommando 02

KOM02:
		ori	r4,r0,TXK2
		jal     print_string

		j       KOMIN


; Kommando 03

KOM03:
		ori	r4,r0,TXK3
		jal     print_string

		j       KOMIN


; Kommando 04

KOM04:
		ori	r4,r0,TXK4
		jal     print_string

		j       KOMIN


; Kommando 05

KOM05:
		ori	r4,r0,TXK5
		jal     print_string

		j       KOMIN


; Kommando 06

KOM06:
		ori	r4,r0,TXK6
		jal     print_string

		j       KOMIN

; Kommando 07

ENDE:
		ori	r4,r0,TXK7
		jal     print_string

		syscall	0		;Ende durch syscall 0 im Simulator


; Unterprogramme
; ==============

; 2. Eingabe eines Zeichen von Tastatur
;
;   OUT  R20,R25
;   KILL R15,R31
INCHAR:
		add     r15,r0,r31			;Ruecksprung vom JAL nach R15
		jal     PUSH				; r15 bis r19 retten
		add	r25,	r0,	r0		; clr	r25, Kein PG Ende / kein Fehler
		add	r20,	r0,	r0		; clr	r20, Eingabewert loeschen
		ori	r4,	r0,	input_puffer
		jal	input_string

		ori	r14,	r0,	input_puffer
		slti	r15,	r1,	2		; Maximal 1 Zeichen
		beq	r15,r0,	inwerr			; mehr als 1 Zeichen eingegeben!
		beq	r1,r0,	inwpge			; keine Eingabe -> PG-ENDE

		lbu	r20,	0(r14)
		ori	r4,	r0,	input_puffer	; Eingabe noch auf der Konsole anzeigen
		jal	print_string
		jal     POP				; r15 bis r19 zurueckladen
		jr      r15

inwerr:		addi	r25,	r0,	-1		; Eingabe Wiederholen
		jal     POP				; r15 bis r19 zurueckladen
		jr      r15
inwpge:		addiu	r25,	r0,	1		; PG-ENDE
inwen:		jal     POP				; r15 bis r19 zurueckladen
		jr      r15


; 3. Kommandoauswertung und Ermittlung des Sprungziels
;
;  IN    R20=Kommando
;  OUT   R20=Zieladresse
;  KILL  R15,R31
;
;  hinter UP-Aufruf muss folgende Befehlsfolge stehen !
;
;       	jr      r20     ;Start des Kommando
;       	j       error   ;Errormeldung bei Kommandofehler
;

; Testen auf gueltiges Kommando

UP_KOMV:
		add     r15,r0,r31		;Ruecksprung vom JAL nach R15
		jal     PUSH			; r15 bis r19 retten
		ori	r16,r0,KOMTAB
		addiu   r17,r0,EKOM - KOMTAB	;LKOM Anzahl der Kommandos
ZYK:    	lbu     r18,0(r16)
		addiu   r16,r16,1		; 1 Byte pro Zeichen
		beq     r18,r20,FIND
		addiu   r17,r17,-1		; 1 Byte pro Zeichen
		bne	r17,r0,ZYK

; Fehlerhaftes Kommando

		jal     POP			; r15 bis r19 zurueckladen
		addiu   r15,r15,4
		jr      r15

; Kommandoadresse bereitstellen

FIND:		addiu   r16,r0,EKOM - KOMTAB	;LKOM
		subu    r17,r16,r17
		sll     r17,r17,3               ; r17 * 8 , weil DWorte 8 Byte haben!
		ori	r16,r0,ADRTAB
		addu    r16,r16,r17
		lw      r20,0(r16)
		jal     POP			; r15 bis r19 zurueckladen
		jr      r15


; 4. Retten von Registern im Stack
;
;  R15 bis R19 werden gerettet
;
;  KILL  R31
;
PUSH:		addiu   r29,r29,-20
		sw      r15,0 (r29)
		sw      r16,4 (r29)
		sw      r17,8 (r29)
		sw      r18,12(r29)
		sw      r19,16(r29)
		jr      r31

; 5. Rueckladen von Registern aus dem Stack
;
;  R15 bis R19 werden rueckgeladen
;
;  KILL  R31
;
POP:		lw      r15,0 (r29)
		lw      r16,4 (r29)
		lw      r17,8 (r29)
		lw      r18,12(r29)
		lw      r19,16(r29)
		addiu   r29,r29,20
		jr      r31

; 1. Zeichenkettenausgabe
;   KILL R4,R14,R31
; Ausgabe einer Zeichenkette ohne Wert Anzeige
; mit dem UP print_string
		#include	print.s


; 3. Eingabe einer Zeichenkette
; mit dem UP input_string
		#include	input.s

;		.end
